var FFN = FFN || {};
FFN.MC = FFN.MC || {};
FFN.MC.prelanders = (function (win, doc, undef) {
    var LibEvents = (function () {
            var fn = {
                normalize: function (e) {
                    if (window.event) {
                        var de = doc.documentElement,
                            db = doc.body;
                        e = window.event;
                        e.relatedTarget = e.type === "mouseover" ? e.fromElement : e.toElement;
                        e.target = e.srcElement || document;
                        e.layerX = e.offsetX;
                        e.layerY = e.offsetY;
                        e.pageX = e.clientX + ((de && de.scrolLeft) || (db && db.scollLeft) || 0);
                        e.pageY = e.clientY + ((de && de.scrolTop) || (db && db.scollTop) || 0);
                        if (!e.preventDefault) {
                            e.preventDefault = function () {
                                e.returnValue = false;
                            };
                        }
                        if (!e.stopPropagation) {
                            e.stopPropagation = function () {
                                e.cancelBubble = true;
                            };
                        }
                    }
                    e.keyCode = e.keyCode || e.charCode || 0;
                    e.stopEvent = function () {
                        e.stopPropagation();
                        e.preventDefault();
                    };
                    return e;
                },
                add: function (elm, type, fn) {
                    var func = fn,
                        eTypeFn = "",
                        typeFn = "",
                        onType = "on" + type,
                        normalize = this.normalize,
                        eventBridge = function (e) {
                            var evt = normalize(e);
                            func.call(this, evt);
                        };
                    if (elm.addEventListener) {
                        elm.addEventListener(type, eventBridge, false);
                    } else if (elm.attachEvent) {
                        typeFn = type + eventBridge;
                        eTypeFn = "e" + typeFn;
                        elm[eTypeFn] = eventBridge;
                        elm[typeFn] = function () {
                            elm[eTypeFn](window.event);
                        };
                        elm.attachEvent(onType, elm[typeFn]);
                    } else {
                        elm[onType] = eventBridge;
                    }
                },
                remove: function (elm, type, fn, useCapture) {
                    var typeFn = "",
                        onType = "on" + type;
                    if (elm.removeEventListener) {
                        elm.removeEventListener(type, fn, useCapture);
                    } else if (elm.detachEvent) {
                        typeFn = type + fn;
                        elm.detachEvent(onType, elm[typeFn]);
                        elm[typeFn] = null;
                    } else {
                        elm[onType] = null;
                    }
                },
            };
            return { normalize: fn.normalize, add: fn.add, remove: fn.remove };
        })(),
        Lib = (function () {
            var supplant = function (str, obj) {
                    return str.replace(/\{JS_([^\{\}]*)\}/g, function (a, b) {
                        var r = obj[b];
                        return typeof r === "string" || typeof r === "number" ? r : r === null ? "" : "{" + typeof r + "}";
                    });
                },
                getNowMS = function () {
                    return +new Date();
                },
                padZero = function (num) {
                    return num < 10 ? "0" + num : num;
                },
                byId = function (id) {
                    return doc.getElementById(id);
                };
            return { supplant: supplant, getNowMS: getNowMS, padZero: padZero, byId: byId };
        })(),
        CreativeMain = (function () {
            var cfg = {},
                layout = {
                    questionAnswers: function () {
                        var cfgi8n = cfg.i8n,
                            questionsAnswered = 0,
                            questionsNo = 1,
                            opts = {
                                hideClsName: "hide",
                                elmQuestions: Lib.byId("questions"),
                                elmQuestion: Lib.byId("question"),
                                elmAnswers: Lib.byId("answers"),
                                elmProgressTitle: Lib.byId("progress_title"),
                                elmProgress: Lib.byId("progress"),
                                elmStatus: Lib.byId("status"),
                                elmRules: Lib.byId("rules_container"),
                                elmRulesCopy: Lib.byId("rules_copy"),
                                elmThemeHeader: Lib.byId("theme_header"),
                                reddiv: Lib.byId("content_head"),
                                footerid: Lib.byId("footerid"),
                                elmQna: Lib.byId("qna"),
                                questions: (function () {
                                    var questions = [cfgi8n.question_1, cfgi8n.question_2, cfgi8n.question_3];
                                    if (cfgi8n.question_4 !== "") {
                                        questions.push(cfgi8n.question_4);
                                    }
                                    return questions;
                                })(),
                                statusChecks: [cfgi8n.statusCheck_1, cfgi8n.statusCheck_2, cfgi8n.statusCheck_3, ""],
                                progressTitles: [cfgi8n.progressTitle_1, cfgi8n.progressTitle_2, cfgi8n.progressTitle_3, cfgi8n.progressTitle_4, cfgi8n.progressTitle_5],
                            },
                            setQuestion = function (qIdx, callback) {
                                var elmQuestions = opts.elmQuestions,
                                    elmQuestion = opts.elmQuestion,
                                    questions = opts.questions,
                                    timer = null,
                                    questionIdx = qIdx < questions.length ? qIdx : 0;
                                elmQuestions.className = opts.hideClsName;
                                timer = setTimeout(function () {
                                    if (questionsAnswered === questions.length) {
                                        callback();
                                    } else {
                                        clearTimeout(timer);
                                        timer = null;
                                        elmQuestion.innerHTML = Lib.supplant(questions[questionIdx], { questionNumber: questionsNo });
                                        elmQuestions.className = "";
                                        questionsNo += 1;
                                        questionsAnswered += 1;
                                    }
                                }, 250);
                            },
                            doQuestions = function (e) {
                                var tgt = e.target,
                                    layout = cfg.urlQS.layout,
                                    isLayoutQnAOnly = layout === "qna";
                                e.stopEvent();
                                if (tgt.nodeName.toUpperCase() === "A") {
                                    setQuestion(questionsAnswered, function () {
                                        var city = cfg.geo.city,
                                            membersCount = cfg.members.state,
                                            location = cfg.geo.state,
                                            scrollTop = cfg.doScrollTop,
                                            elmAnswers = opts.elmAnswers,
                                            elmProgressTitle = opts.elmProgressTitle,
                                            elmProgress = opts.elmProgress,
                                            elmStatus = opts.elmStatus,
                                            elmRules = opts.elmRules,
                                            elmRulesCopy = opts.elmRulesCopy,
                                            elmThemeHeader = opts.elmThemeHeader,
                                            reddiv = opts.reddiv,
                                            footerid = opts.footerid,
                                            elmQna = opts.elmQna,
                                            statusChecks = opts.statusChecks,
                                            progressTitles = opts.progressTitles,
                                            timer = null,
                                            idx = 0;
                                        if (membersCount === "") {
                                            location = cfg.geo.country;
                                            membersCount = cfg.members.country;
                                        }
                                        if (city === "") {
                                            city = location;
                                        }
                                        if (!isLayoutQnAOnly) {
                                            elmRulesCopy.className = opts.hideClsName;
                                        }
                                        if (membersCount === "") {
                                            statusChecks[0] = cfg.i8n.noDataStatusCheck_1;
                                        }
                                        if (scrollTop) {
                                            window.scroll(0, 0);
                                        }
                                        elmThemeHeader.className = opts.hideClsName;
                                        reddiv.className = opts.hideClsName;
                                        footerid.className = opts.hideClsName;
                                        elmQna.className = "progress_title_button_" + layout;
                                        elmAnswers.className = "";
                                        elmProgressTitle.innerHTML = progressTitles[idx];
                                        timer = setInterval(function () {
                                            elmProgressTitle.innerHTML = Lib.supplant(progressTitles[idx + 1], { membersCount: membersCount, location: city });
                                            if (isLayoutQnAOnly) {
                                                elmStatus.innerHTML += "<li>" + Lib.supplant(statusChecks[idx], { membersCount: membersCount, location: location }) + "</li>";
                                            }
                                            idx += 1;
                                            if (idx === statusChecks.length) {
                                                clearInterval(timer);
                                                timer = null;
                                                elmProgress.className = opts.hideClsName;
                                                elmRules.className = "";
                                            }
                                        }, 2500);
                                    });
                                }
                            },
                            attachHandlers = function () {
                                LibEvents.add(opts.elmQuestions, "click", doQuestions);
                            },
                            init = function () {
                                var startAtQuestion = parseInt(cfg.urlQS.startAtQuestion, 10) || 0;
                                questionsAnswered = startAtQuestion < opts.questions.length ? startAtQuestion : 0;
                                setQuestion(questionsAnswered);
                                attachHandlers();
                            };
                        init();
                    },
                    countDown: function () {
                        var opts = { startTime: 0, duration: 61000, warning: { ms: 11000, clsName: "warning" }, closing: { ms: 6000, clsName: "alert" }, elmTimer: Lib.byId("timer"), elmMin: Lib.byId("min"), elmSec: Lib.byId("sec") },
                            doTimer = function () {
                                var timer = null;
                                opts.startTime = Lib.getNowMS();
                                timer = setInterval(function () {
                                    var min = 0,
                                        sec = 0,
                                        elapsedTime = Lib.getNowMS() - opts.startTime,
                                        remainingTime = opts.duration - elapsedTime;
                                    if (remainingTime < 0) {
                                        clearInterval(timer);
                                        opts.elmTimer.className = "";
                                        doTimer();
                                    } else {
                                        if (remainingTime < opts.warning.ms && remainingTime > opts.closing.ms) {
                                            opts.elmTimer.className = opts.warning.clsName;
                                        } else if (remainingTime < opts.closing.ms) {
                                            opts.elmTimer.className = opts.closing.clsName;
                                        }
                                        sec = Math.floor((remainingTime % 60000) / 1000);
                                        min = Math.floor((remainingTime % 3600000) / 60000);
                                        opts.elmMin.innerHTML = Lib.padZero(min);
                                        opts.elmSec.innerHTML = Lib.padZero(sec);
                                    }
                                }, 100);
                            };
                        doTimer();
                    },
                },
                init = function (config) {
                    cfg = config;
                    if (/^qna1?$/.test(cfg.urlQS.layout.toLowerCase())) {
                        layout.questionAnswers();
                    } else {
                        layout.countDown();
                    }
                };
            return { init: init };
        })();
    return { init: CreativeMain.init };
})(window, document);
